﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// 空白頁項目範本已記錄在 https://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x404

namespace i8024W_Basic_Info_Csharp
{
    /// <summary>
    /// 可以在本身使用或巡覽至框架內的空白頁面。
    /// </summary>
    public sealed partial class MainPage : Page
    {
        Int16 slot = 0;
        public MainPage()
        {
            this.InitializeComponent();
            Library_ver_txt.Text = String.Format("{0:X4}", pac8024WNet.pac8024W.LibVersion());
            Library_date_txt.Text = pac8024WNet.pac8024W.LibDate();
        }

        private void slot_cbx_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            slot = (Int16)slot_cbx.SelectedIndex;
            if (pac8024WNet.pac8024W.Init(slot) == 0)
            {
                FW_ver_txt.Text = String.Format("{0:X4}", pac8024WNet.pac8024W.FirmwareVersion(slot));
                Status_txt.Text = "Init OK!!";
            }
            else{
                Status_txt.Text = "Init Failed!!";
            }
        }

        private void btn_Click(object sender, RoutedEventArgs e)
        {
            Int16 ch = 0;
            Button btn = sender as Button;
            ComboBox[] type_cbx = new ComboBox[4] { T0_cbx , T1_cbx , T2_cbx , T3_cbx };
            TextBox[] data_txt = new TextBox[4] { D0_txt, D1_txt, D2_txt, D3_txt };
            switch (btn.Content)
            {
                case "O0_btn":
                    {
                        ch = 0;
                        break;
                    }
                case "O1_btn":
                    {
                        ch = 1;
                        break;
                    }
                case "O2_btn":
                    {
                        ch = 2;
                        break;
                    }
                case "O3_btn":
                    {
                        ch = 3;
                        break;
                    }
            }
            switch (type_cbx[ch].SelectedIndex)
            {
                case 0:
                    {
                        pac8024WNet.pac8024W.VoltageOut(slot, ch, float.Parse(data_txt[ch].Text));
                        break;
                    }
                case 1:
                    {
                        pac8024WNet.pac8024W.CurrentOut(slot, ch, float.Parse(data_txt[ch].Text));
                        break;
                    }
                case 2:
                    {
                        pac8024WNet.pac8024W.VoltageOut_Hex(slot, ch, Int16.Parse(data_txt[ch].Text));
                        break;
                    }
                case 3:
                    {
                        pac8024WNet.pac8024W.CurrentOut_Hex(slot, ch, Int16.Parse(data_txt[ch].Text));
                        break;
                    }
            }
        }

        private void Exit_btn_Click(object sender, RoutedEventArgs e)
        {
            Application.Current.Exit();
        }
    }
}
