﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
namespace pac8024WNet
{
    public class pac8024W
    {
        private class ICPDAS
        {
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_GetLibVersion")]
            public static extern Int16 pac_i8024W_GetLibVersion();
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_GetFirmwareVersion")]
            public static extern Int16 pac_i8024W_GetFirmwareVersion(Int16 slot);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_GetLibDate")]
            public static extern void pac_i8024W_GetLibDate(byte[] libDate);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_Initial")]
            public static extern Int16 pac_i8024W_Initial(Int16 slot);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_VoltageOut")]
            public static extern void pac_i8024W_VoltageOut(Int16 slot, Int16 ch, float fData);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_VoltageOut_Hex")]
            public static extern void pac_i8024W_VoltageOut_Hex(Int16 slot, Int16 ch, Int16 hData);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_CurrentOut")]
            public static extern void pac_i8024W_CurrentOut(Int16 slot, Int16 ch, float fData);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_CurrentOut_Hex")]
            public static extern void pac_i8024W_CurrentOut_Hex(Int16 slot, Int16 ch, Int16 hData);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_VoltageOut_Readback")]
            public static extern float pac_i8024W_VoltageOut_Readback(int slot, int ch);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_VoltageOut_Hex_Readback")]
            public static extern int pac_i8024W_VoltageOut_Hex_Readback(int slot, int ch);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_CurrentOut_Readback")]
            public static extern float pac_i8024W_CurrentOut_Readback(int slot, int ch);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_CurrentOut_Hex_Readback")]
            public static extern int pac_i8024W_CurrentOut_Hex_Readback(int slot, int ch);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "I8024_ReadGainOffsetInfo")]
            public static extern void pac_i8024_ReadGainOffsetInfo(int slot, int ch, int type, ref float gain, ref float offset);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_ReadVoltageGain")]
            public static extern void pac_i8024W_ReadVoltageGain(int slot, int ch, ref int vMax, ref int vMin);
            [DllImport("pac_i8024W_UWP_x64.dll", EntryPoint = "pac_i8024W_ReadCurrentGain")]
            public static extern void pac_i8024W_ReadCurrentGain(int slot, int ch, ref int iMax, ref int iMin);
        }
        public static Int16 LibVersion()
        {
            return ICPDAS.pac_i8024W_GetLibVersion();
        }
        public static string LibDate()
        {
            byte[] libDate = new byte[32];
            ICPDAS.pac_i8024W_GetLibDate(libDate);
            return AscArr2Str(libDate);
        }
        public static Int16 Init(Int16 slot)
        {
            return ICPDAS.pac_i8024W_Initial(slot);
        }
        public static Int16 FirmwareVersion(Int16 slot)
        {
            return ICPDAS.pac_i8024W_GetFirmwareVersion(slot);
        }
        public static void VoltageOut_Hex(Int16 slot, Int16 ch, Int16 hData)
        {
            ICPDAS.pac_i8024W_VoltageOut_Hex(slot, ch, hData);
        }
        public static void VoltageOut(Int16 slot, Int16 ch, float fData)
        {
            ICPDAS.pac_i8024W_VoltageOut(slot, ch, fData);
        }
        public static void CurrentOut(Int16 slot, Int16 ch, float fData)
        {
            ICPDAS.pac_i8024W_CurrentOut(slot, ch, fData);
        }
        public static void CurrentOut_Hex(Int16 slot, Int16 ch, Int16 hData)
        {
            ICPDAS.pac_i8024W_CurrentOut_Hex(slot, ch, hData);
        }
        public static float VoltageOut_Readback(Int16 slot, Int16 ch)
        {
            return ICPDAS.pac_i8024W_VoltageOut_Readback(slot, ch);
        }
        public static float CurrentOut_Readback(Int16 slot, Int16 ch)
        {
            return ICPDAS.pac_i8024W_CurrentOut_Readback(slot, ch);
        }
        public static Int16 VoltageOut_Hex_Readback(Int16 slot, Int16 ch)
        {
            return (Int16)ICPDAS.pac_i8024W_VoltageOut_Hex_Readback(slot, ch);
        }
        public static Int16 CurrentOut_Hex_Readback(Int16 slot, Int16 ch)
        {
            return (Int16)ICPDAS.pac_i8024W_CurrentOut_Hex_Readback(slot, ch);
        }
        private static string AscArr2Str(byte[] b)
        {
            return System.Text.UnicodeEncoding.Unicode.GetString(
            System.Text.ASCIIEncoding.Convert(System.Text.Encoding.ASCII,
            System.Text.Encoding.Unicode, b), 0, b.Length);
        }
        public static string Arr2Str(byte[] buffer)
        {
            return (new UnicodeEncoding()).GetString(buffer, 0, buffer.Length);
        }
        public static void Voltage_Gain(Int16 slot, Int16 ch, ref int vMax, ref int vMin)
        {
            ICPDAS.pac_i8024W_ReadVoltageGain(slot, ch, ref vMax, ref vMin);
        }
        public static void Current_Gain(Int16 slot, Int16 ch, ref int iMax, ref int iMin)
        {
            ICPDAS.pac_i8024W_ReadCurrentGain(slot, ch, ref iMax, ref iMin);
        }
        public static void ReadGainOffsetInfo(int slot, int ch, int type, ref float gain, ref float offset)
        {
            ICPDAS.pac_i8024_ReadGainOffsetInfo(slot, ch, type, ref gain, ref offset);
        }
    }
}